<?php
/*
  Copyright (c) 2007-2009 Rod Gasson / VCSWEB
  Released under the GNU General Public License

 $Id: ozpost.php,v1.0.0  Feb 2009

            var_dump(get_defined_vars());
*/

// class constructor
class ozpost extends base {

  /**
   * Declare shipping module alias code
   *
   * @var string
   */
  var $code;

  /**
   * Shipping module display name
   *
   * @var string
   */
  var $title;

  /**
   * Shipping module display description
   *
   * @var string
   */
  var $description;

  /**
   * Shipping module icon filename/path
   *
   * @var string
   */
  var $icon;

  /**
   * Shipping module status
   *
   * @var boolean
   */
  var $enabled;

  /**
// var $code, $title, $description, $icon, $enabled;
*/


function ozpost() {

    global $order, $db, $template, $ipath, $ipath2 ;

// disable only when entire cart is free shipping
if (zen_get_shipping_enabled($this->code))  $this->enabled = ((MODULE_SHIPPING_OZPOST_STATUS == 'True') ? true : false);

$ipath = DIR_WS_TEMPLATE.",".$current_page_base ; $ipath2 = "images/icons" ;

$this->code = 'ozpost';
$this->title = 'Australia Post' ;
$this->description = 'Australia Post \(ozpost\)';
$this->sort_order = MODULE_SHIPPING_OZPOST_SORT_ORDER;
$this->icon = $template->get_template_dir('ozpost.jpg', $ipath,$ipath2). '/ozpost.jpg';
        if (zen_not_null($this->icon)) $this->quotes['icon'] = zen_image($this->icon, $this->title);
$this->icon_del = $template->get_template_dir('ozpost_del.jpg', $ipath,$ipath2). '/ozpost_del.jpg';
$this->logo = $template->get_template_dir('ozpost_logo.jpg', $ipath,$ipath2). '/ozpost_logo.jpg';
$this->tax_class = MODULE_SHIPPING_OZPOST_TAX_CLASS;
$this->tax_basis = 'Shipping' ;    // It'll always work this way, regardless of any global settings

if (MODULE_SHIPPING_OZPOST_ICONS == "Yes" ) {
    if (zen_not_null($this->logo)) $this->title = zen_image($this->logo, $this->title) ;
}


$this->allowed_methods = array_merge (explode(", ", MODULE_SHIPPING_OZPOST_TYPES1), explode(", ", MODULE_SHIPPING_OZPOST_TYPES2)) ;

$this->codes =  array (
        'SLET' , 'LL1'  , 'LL2'   , 'LL3',
        'REGL' , 'REGLS', 'REGLL' ,
        'SLETi', 'LL1i' , 'LL2i'  , 'LL3i'  ,
        'INSLS', 'INSLL',
        'RPP'  , 'RPPi' , 'REG'   , 'EXP'   , 'EPI', 'EXPi', 'EPIi',
        'PPS5' , 'PPS3' , 'PPSE5' , 'PPSE3',
        'COD'  ,
        'AIR'  , 'SEA'  , 'AIRi'  , 'SEAi'  ,
        'ECId' , 'ECIm'
    ) ;


    // create icon image strings //
    foreach($this->codes as $code )  {
        $ext = strtolower($code) ; $icon = "ozpost_".$ext.".jpg"  ;
        $this->icons["$code"] = $template->get_template_dir($icon, $ipath, $ipath2).'/'.$icon ;
    }

}

// class methods
function quote($method = '') {
    global $db, $order,$cart, $shipping_weight, $shipping_num_boxes, $currencies , $ipath, $ipath2 ;

    if (zen_not_null($method) && (isset($_SESSION['_ozpost_quotes']))) {

        $testmethod = $_SESSION['_ozpost_quotes']['methods'] ;

        foreach($testmethod as $temp) {
            $search = array_search("$method", $temp) ;

            if (strlen($search) > 0 && $search >= 0) {
                ;  break ;
            }
        } ;

$usemod = $this->title ; $usetitle = $temp['title'] ;

if (MODULE_SHIPPING_OZPOST_ICONS == "Yes" ) {  // strip the icons //
if (preg_match('/(title)=("[^"]*")/',$this->title, $module))  $usemod = trim($module[2], "\"") ;
if (preg_match('/(title)=("[^"]*")/',$temp['title'], $title)) $usetitle = trim($title[2], "\"") ;
}

$this->quotes = array('id' => $this->code, 'module' => $usemod,
            'methods' => array( array(
                'id' => $method,
                'title' => $usetitle,
                'cost' =>  $temp['cost'])));

        if ($this->tax_class >  0) { $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']); }

return $this->quotes;   // return a single quote

    }  ////////////////////////////  Single Quote Exit Point //////////////////////////////////


//$SERVER  = "localhost" ;
$SERVER  = "ozpost.vcsweb.com" ;
$VERSION  = "1.0.0" ;

// Maximums
$MAXWEIGHT_P = 20000 ; // 20kgs
$MAXLENGTH_P = 105 ;  // 105cm max parcel length
$MAXGIRTH_P =  140 ;  // 140cm max parcel girth  ( (width + height) * 2)


// default dimensions //
$x = split(',', MODULE_SHIPPING_OZPOST_DIMS) ;
$defaultdims = array($x[0],$x[1],$x[2]) ; sort($defaultdims) ;  // length[2]. width[1], height=[0]


// initialise variables
$parcelwidth = 0 ; $parcellength = 0 ;  $parcelheight = 0 ;  $parcelweight = 0 ;  $cube = 0 ;

$frompcode = MODULE_SHIPPING_OZPOST_SPCODE; $dest_country=$order->delivery['country']['iso_code_2']; $topcode = str_replace(" ","",($order->delivery['postcode']));

$aus_rate = $currencies->get_value(AUD) ;
$xchange = $currencies->get_value($_SESSION['currency']) ;
$tare = MODULE_SHIPPING_OZPOST_TARE ;
// loop through cart extracting productIDs and qtys //

    $myorder = $_SESSION['cart']->get_products();

    for($x = 0 ; $x < count($myorder) ; $x++ ) {

        $t = $myorder[$x]['id']  ;
        $q = $myorder[$x]['quantity'] ;

        $dim_query = "select products_length, products_height, products_width, products_weight from " . TABLE_PRODUCTS . " where products_id='$t' limit 1 ";
        $dims = $db->Execute($dim_query);

      // re-orientate //
        $var = array($dims->fields['products_width'], $dims->fields['products_height'], $dims->fields['products_length']) ; sort($var) ;
        $dims->fields['products_length'] = $var[2] ; $dims->fields['products_width'] = $var[1] ;  $dims->fields['products_height'] = $var[0] ;
          // if no dimensions provided use the defaults
            if($dims->fields['products_height'] == 0) {$dims->fields['products_height'] = $defaultdims[0] ; }
            if($dims->fields['products_width']  == 0) {$dims->fields['products_width']  = $defaultdims[1] ; }
            if($dims->fields['products_length'] == 0) {$dims->fields['products_length'] = $defaultdims[2] ; }
            if($dims->fields['products_weight'] == 0) {$dims->fields['products_weight'] = 1 ; }  // 1 gram minimum helps avoid errors

            $parcelweight = $parcelweight + ( $dims->fields['products_weight'] * $q ) ;
        // get the cube of these items
            $itemcube =  ($dims->fields['products_width'] * $dims->fields['products_height'] * $dims->fields['products_length'] * $q) ;
            // Increase widths and length of parcel as needed
            if ($dims->fields['products_width'] >  $parcelwidth)  { $parcelwidth  = $dims->fields['products_width']  ; }
            if ($dims->fields['products_length'] > $parcellength) { $parcellength = $dims->fields['products_length'] ; }
            // Stack on top on existing items
            $parcelheight =  ($dims->fields['products_height'] * ($q)) + $parcelheight  ;
            $packageitems =  $packageitems + $q ;

            // Useful debugging information //
      if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" ) {
         $dim_query = "select products_name from " . TABLE_PRODUCTS_DESCRIPTION . " where products_id='$t' limit 1 ";
        $name = $db->Execute($dim_query);

           echo "<center><table border=1 width=95% ><th colspan=8>Debugging information</hr>
            <tr><th>Item " . ($x + 1) . "</th><td colspan=7>" . $name->fields['products_name'] . "</td>
            <tr><th width=1%>Attribute</th><th colspan=3>Item</th><th colspan=4>Parcel</th></tr>
            <tr><th>Qty</th><td>&nbsp; " . $q . "<th>Weight</th><td>&nbsp; " . $dims->fields['products_weight'] . "</td>
            <th>Qty</th><td>&nbsp;$packageitems</td><th>Weight</th><td>&nbsp;" ; echo $parcelweight + (($parcelweight* $tare)/100) ; echo "</td></tr>
            <tr><th>Dimensions</th><td colspan=3>&nbsp; " . $dims->fields['products_length'] . " x " . $dims->fields['products_width'] . " x "  . $dims->fields['products_height'] . "</td>
            <td colspan=4>&nbsp;$parcellength  x  $parcelwidth  x $parcelheight </td></tr>
            <tr><th>Cube</th><td colspan=3>&nbsp; " . $itemcube . "</td><td colspan=4>&nbsp;" . ($parcelheight * $parcellength * $parcelwidth) . " </td></tr>
            <tr><th>CubicWeight</th><td colspan=3>&nbsp;" . (($dims->fields['products_length'] * $dims->fields['products_height'] * $dims->fields['products_width']) * 0.000001 * 250) . "Kgs  </td><td colspan=4>&nbsp;" . (($parcelheight * $parcellength * $parcelwidth) * 0.000001 * 250) . "Kgs </td></tr>
            </table></center> " ;
          }
    }


// package created, now re-orientate and check dimensions
$var = array($parcelheight, $parcellength, $parcelwidth) ; sort($var) ;
$parcelheight = $var[0] ; $parcelwidth = $var[1] ; $parcellength = $var[2] ;
$girth = ($parcelheight * 2) + ($parcelwidth * 2)  ;

$parcelweight = $parcelweight + (($parcelweight*$tare)/100) ;

 // Check for maximum length allowed
if($parcellength > $MAXLENGTH_P)  {
        $methods[] = array( 'id' => 'Australia Post ',  'title' => $this->code . '<font color=#FF0000> ERROR: ' . $parcellength . 'cm exceeds the Maximum 105cm length allowed.</font>', 'cost' => 'NA' ) ;
        $this->quotes['methods'] = $methods;   // set it
        return $this->quotes;
    }  // exceeds AustPost maximum length. No point in continuing.

// Check girth
if($girth > $MAXGIRTH_P ) {

      $methods[] = array( 'id' => 'Australia Post ',  'title' => $this->code . '<font color=#FF0000> ERROR: ' . $parcelheight . "+" . $parcelwidth . ') x 2) cm exceeds the Maximum 140cm girth allowed.</font>', 'cost' => 'NA' ) ;
        $this->quotes['methods'] = $methods;   // set it
        return $this->quotes;
    }  // exceeds AustPost maximum girth. No point in continuing.


    if ($parcelweight > $MAXWEIGHT_P) {
    $methods[] = array( 'id' => 'Australia Post',  'title' => $this->code . '<font color=#FF0000> ERROR: ' . $sweight . 'Parcel Exceeds the 20kg Maximum allowed.</font>' , 'cost' => 'NA' ) ;
    $this->quotes['methods'] = $methods;   // set it
return $this->quotes; }  // exceeds AustPost maximum weight. No point in continuing.



// Check to see if cache is useful
if(isset($_SESSION['_ozpost_parcel'])) {

   $test = explode(",", $_SESSION['_ozpost_parcel'])  ;

        if(($test[0] == $dest_country) &&  ($test[1] == $topcode) && ($test[2] == $parcelwidth)
            &&  ($test[3] == $parcelheight) && ($test[4] == $parcellength) && ($test[5] == $parcelweight)) {

 if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" ) {
           echo "<center><table border=1 width=95% ><td align=center><font color=\"#FF0000\">Using Cached quotes </font></td></table></center>" ;


      }

return $_SESSION['_ozpost_quotes'] ;

 ///////////////////////////////////  Cache Exit Point //////////////////////////////////

    } // No cache match -  get new quote from server //

 }  // No cache session -  get new quote from server //
///////////////////////////////////////////////////////////////////////////////////////////////

// always save new session  CSV //
$_SESSION['_ozpost_parcel'] = implode(",", array($dest_country, $topcode, $parcelwidth,$parcelheight,$parcellength,$parcelweight)) ;
$shipping_weight = $parcelweight ;  // global value for zencart

// convert cm to mm 'cos thats what the server uses //
$parcelwidth = $parcelwidth * 10 ; $parcelheight = $parcelheight * 10 ; $parcellength = $parcellength * 10 ;

// Set destination code ( postcode if AU, else 2 char iso country code )
$dcode = ($dest_country == "AU") ? $topcode:$dest_country ;

$flags = ((MODULE_SHIPPING_OZPOST_HIDE_PARCEL == "No") || ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" )) ? 0:1 ;


// Server query string //
$qu = $this->_getAPdata($SERVER, "/postage.php?fromcode=" . MODULE_SHIPPING_OZPOST_SPCODE ."&destcode=$dcode&weight=$parcelweight&height=$parcelheight&width=$parcelwidth&length=$parcellength&value=$value&flags=$flags&$method=$method&client=$client") ;
// $qu = $this->_getAPdata($SERVER, "/zencart/postage.php?fromcode=" . MODULE_SHIPPING_OZPOST_SPCODE ."&destcode=$dcode&weight=$parcelweight&height=$parcelheight&width=$parcelwidth&length=$parcellength&value=$value&flags=$flags&$method=$method&client=$client") ;

// Parse the .xml results into an array //
 $xml = new SimpleXMLElement($qu)  ;


/////  Initialise our quote array(s)
$this->quotes = array('id' => $this->code, 'module' => $this->title);
$methods = array() ;

///////////////////////////////////////
//
//  loop through the quotes retrieved //

$i = 0 ;  // counter
foreach($xml as $foo => $bar )  {

$id = ($xml->quote[$i]->id);
$cost = (float)($xml->quote[$i]->cost);
$description = ($xml->quote[$i]->description);
$days = ($xml->quote[$i]->days) + MODULE_SHIPPING_OZPOST_DOFFSET ;
$i++ ;

$add = 0 ; $f = 0 ;
        if ((in_array("Letters", $this->allowed_methods)) && (($id == "SLET") || ($id == "LL1")   || ($id == "LL2") || ($id == "LL3"))) {
            $add =  MODULE_SHIPPING_OZPOST_LET_HANDLING; $f = 1 ;
        }

        if ((in_array("Registered Letters", $this->allowed_methods)) && (($id == "REGL") || ($id == "REGLS") || ($id == "REGLL"))) {
            $add =  MODULE_SHIPPING_OZPOST_LET_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING; $f = 1 ;
        }

       if ( (in_array("Insured Letters", $this->allowed_methods)) && (($id == "SLETi") || ($id == "LL1i") || ($id == "LL2i") || ($id == "LL3i") || ($id == "INSLS") || ($id == "INSLL"))) {
            $add = MODULE_SHIPPING_OZPOST_LET_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING; $f = 1 ;
        }

        if ((in_array("Prepaid Satchel", $this->allowed_methods)) && (( $id == "PPS5" ) || ($id == "PPS3"))) {
            $add = MODULE_SHIPPING_OZPOST_PPS_HANDLING ; $f = 1 ;
        }

        if ((in_array("Prepaid Express Satchel", $this->allowed_methods)) && (( $id == "PPSE5" ) || ( $id == "PPSE3" ))) {
            $add =  MODULE_SHIPPING_OZPOST_PPSE_HANDLING ; $f = 1 ;
        }

        if (in_array("Regular Parcel", $this->allowed_methods) && ( $id == "RPP")) {
            $add = MODULE_SHIPPING_OZPOST_RPP_HANDLING ; $f = 1 ;
        }

        if (in_array("Registered Parcel", $this->allowed_methods) && (  $id == "REG")) {
            $add =  MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING ; $f = 1 ;
        }

        if (in_array("Insured Parcel", $this->allowed_methods)  && ( $id == "RPPi")) {
            $add = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING ; $f = 1 ;
        }

        if (in_array("Express Parcel", $this->allowed_methods)  && ( $id == "EPI" )) {     // international
            $add = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING ; $f = 1 ;
        }

        if (in_array("Express Parcel", $this->allowed_methods) && ( $id == "EXP" )) {        // Aust
            $add = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING ; $f = 1 ;
        }

        if (in_array("Express Parcel Insured", $this->allowed_methods) && ($id == "EXPi" )) {
            $add = MODULE_SHIPPING_OZPOST_RPP_HANDLING + MODULE_SHIPPING_OZPOST_EXP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING; $f = 1 ;
        }

        if (in_array("Express Parcel Insured", $this->allowed_methods)  && ($id == "EPIi" )) {
            $add =MODULE_SHIPPING_OZPOST_INT_HANDLING +  MODULE_SHIPPING_OZPOST_EXP_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING; $f = 1 ;
        }

        if (in_array("Cash on Delivery", $this->allowed_methods) && ( $id == "COD"  )) {
            $add = MODULE_SHIPPING_OZPOST_COD_HANDLING ; $f = 1 ;

        }

        if (in_array("Air Parcel", $this->allowed_methods) && ( $id == "AIR"  )) {
            $add = MODULE_SHIPPING_OZPOST_INT_HANDLING; $f = 1 ;
        }

        if ((in_array("Insured Air", $this->allowed_methods)) && ($id == "AIRi" )) {
            $add = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING ; $f = 1 ;
        }
        if (in_array("Sea", $this->allowed_methods) && ($id == "SEA" )) {
            $add =  MODULE_SHIPPING_OZPOST_INT_HANDLING; $f = 1 ;
        }

        if (in_array("Insured Sea", $this->allowed_methods) && ($id == "SEAi" )) {
            $add = MODULE_SHIPPING_OZPOST_INT_HANDLING + MODULE_SHIPPING_OZPOST_RI_HANDLING ; $f = 1 ;
        }

        if ((in_array("Express Courier International Merchandise", $this->allowed_methods)) && ($id == "ECIm")) {
            $add = MODULE_SHIPPING_OZPOST_ECIM_HANDLING ; $f = 1 ;
        }

        if ((in_array("Express Courier International Documents", $this->allowed_methods)) && ($id == "ECId")) {
            $add = MODULE_SHIPPING_OZPOST_ECID_HANDLING ; $f = 1 ;
        }


        //////////////////////////////
        if ( (($cost > 0) && ($f == 1)) || ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" )) {

        $cost = $cost + $add ;
        
        if (($dest_country == "AU") && (($this->tax_class) > 0)) {

        $t = $cost - ($cost / (zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id'])+1)) ;

       if ($t > 0)  $cost = $t ;
            }

            if  (MODULE_SHIPPING_OZPOST_HIDE_HANDLING !='Yes') {
                $details = ' (Includes ' . $currencies->format($add * $xchange). ' Packaging & Handling). ';
            }

            if (MODULE_SHIPPING_OZPOST_DOFFSET >= 0) {
                $edays = " " . $days . " days Est Delivery"  ;

                if (MODULE_SHIPPING_OZPOST_ICONS == "Yes" ) {
                $edays = " <strong>" . $days . "</strong> " .zen_image($this->icon_del, $edays ) ;
                }
            }

            if (MODULE_SHIPPING_OZPOST_ICONS == "Yes" ) {

                $description= zen_image($this->icons["$id"], $description ) ;

            }

            $methods[] = array( 'id' => "$id",  'title' => " ".$description." ". $edays . " " . $details, 'cost' => ($cost ) );
        }

    }  // end foreach loop

///////////////////////////////////////////////////////////////////////
//
//  check to ensure we have at least one valid quote - produce error message if not.

if  (sizeof($methods) == 0 ) {
        $methods[] = array( 'id' => "Error",  'title' => ' Unknown error (no methods)' ,'cost' => 0 ) ;
    $this->quotes['methods'] = $methods;   // set it
}

//  Sort by cost //
    $sarray[] = array()  ; $resultarr = array() ;

        foreach($methods as $key => $value) {
		$sarray[ $key ] = $value['cost'] ;
    	}

        asort( $sarray ) ;

        foreach($sarray as $key => $value) {
		$resultarr[ $key ] = $methods[ $key ] ;
	}

	$this->quotes['methods'] = array_values($resultarr) ;   // set it

$_SESSION['_ozpost_quotes'] = $this->quotes  ; // save as session to avoid reprocessing when single method required

if ($this->tax_class >  0) { $this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']); }

return $this->quotes;   //  all done //

   ///////////////////////////////////  Final Exit Point //////////////////////////////////

}


////////////////////////////////////////////////////////////////
function check() {
    global $db;
    if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_OZPOST_STATUS'");
        $this->_check = $check_query->RecordCount();
    }
    return $this->_check;
}
////////////////////////////////////////////////////////////////////////////
function install() {

    global $db;
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Enable the ozpost module by <a href =\"http://vcsweb.com\"/><img src=\"http://vcsweb.com/images/vcsweb_logo_zencart_mod.gif\" alt=\"http://vcsweb.com\"></a><br />', 'MODULE_SHIPPING_OZPOST_STATUS', 'True', 'Enable this Module', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");



    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Dispatch Postcode', 'MODULE_SHIPPING_OZPOST_SPCODE', '5161', 'Dispatch Postcode?', '6', '2', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (	configuration_title,
                            configuration_key,
                            configuration_value,
                            configuration_description,
                            configuration_group_id,
                            sort_order,
                            set_function,
                            date_added)

                    values ( 	'Shipping Methods for Australia',
                            'MODULE_SHIPPING_OZPOST_TYPES1',
                                   'Letters, Registered Letters, , Regular Parcel, Registered Parcel, Insured Parcel, Express Parcel, , Prepaid Satchel, , ',
                            'Select the methods you wish to allow',
                            '6',
                            '3',
  'zen_cfg_select_multioption(array(\'Letters\',\'Registered Letters\',\'Insured Letters\',\'Regular Parcel\',\'Registered Parcel\',\'Insured Parcel\',\'Express Parcel\',\'Express Parcel Insured\',\'Prepaid Satchel\',\'Prepaid Express Satchel\',\'Cash on Delivery\'), ',
                            now())") ;

      $db->Execute("insert into " . TABLE_CONFIGURATION . " (	configuration_title,
                            configuration_key,
                            configuration_value,
                            configuration_description,
                            configuration_group_id,
                            sort_order,
                            set_function,
                            date_added)

                    values ( 	'Shipping Methods for Overseas',
                            'MODULE_SHIPPING_OZPOST_TYPES2',
                                   'Letters, , , Air Parcel, Insured Air, , , , , ',
                            'Select the methods you wish to allow',
                            '6',
                            '4',
  'zen_cfg_select_multioption(array(\'Letters\',\'Registered Letters\',\'Insured Letters\',\'Air Parcel\',\'Insured Air\',\'Express Parcel\',\'Express Parcel Insured\',\'Sea\',\'Insured Sea\',\'Express Courier International Documents\',\'Express Courier International Merchandise\'), ',
                            now())") ;

    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Letters', 'MODULE_SHIPPING_OZPOST_LET_HANDLING', '2.00', 'Handling Fee for letters.', '6', '5', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Regular parcels', 'MODULE_SHIPPING_OZPOST_RPP_HANDLING', '5.00', 'Handling Fee Regular parcels (keep in mind that handling fees need to include packaging material)', '6', '6', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Prepaid Satchels', 'MODULE_SHIPPING_OZPOST_PPS_HANDLING', '4.00', 'Handling Fee for Prepaid Satchels.', '6', '7', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Prepaid Satchels - Express', 'MODULE_SHIPPING_OZPOST_PPSE_HANDLING', '5.00', 'Handling Fee for Prepaid Express Satchels.', '6', '8', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Express parcels', 'MODULE_SHIPPING_OZPOST_EXP_HANDLING', '5.00', 'Handling Fee Express parcels - This is <strong>in addition</strong> to other handling fees (excluding Prepaid Express satchels).', '6', '9', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - COD', 'MODULE_SHIPPING_OZPOST_COD_HANDLING', '12.00', 'Handling Fee for COD deliveries', '6', '10', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Overseas parcels', 'MODULE_SHIPPING_OZPOST_INT_HANDLING', '8.00', 'Handling Fee for overseas parcels (These may require additional packaging).', '6', '11', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - ECI Documents', 'MODULE_SHIPPING_OZPOST_ECID_HANDLING', '10.00', 'Handling Fee - ECI Documents.', '6', '12', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - ECI Merchandise', 'MODULE_SHIPPING_OZPOST_ECIM_HANDLING', '10.00', 'Handling Fee - ECI Merchandise.', '6', '13', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Handling Fee - Registered and/or Insured parcels \& letters', 'MODULE_SHIPPING_OZPOST_RI_HANDLING', '2.00', 'Handling Fee for Registered and/or Insured Parcels & Letters - This is <strong>in addition</strong> to other handling fees.', '6', '14', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide Handling Fees?', 'MODULE_SHIPPING_OZPOST_HIDE_HANDLING', 'No', 'The handling fees are still in the total shipping cost but the Handling Fee is not itemised on the invoice.', '6', '16', 'zen_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Parcel Dimensions', 'MODULE_SHIPPING_OZPOST_DIMS', '29,25,2.5', 'Default Parcel dimensions (in cm). Three comma seperated values (eg 29,24,2.5 = 29cm x 24cm x 2.5cm). These are used if the dimensions of individual products are not set', '6', '40', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Parcel Weight format', 'MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT', 'gms', 'Are your store items weighted by grams or Kilos? (required so that we can pass the correct weight to the server).', '6', '17', 'zen_cfg_select_option(array(\'gms\', \'kgs\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Hide parcel rates if letter sized ? ', 'MODULE_SHIPPING_OZPOST_HIDE_PARCEL', 'Yes', 'If the parcel/items are letter sized would you like to hide the parcel postage rates? </br>Note: Has no effect if debug enabled', '6', '18', 'zen_cfg_select_option(array(\'No\', \'Yes\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Show Icons?', 'MODULE_SHIPPING_OZPOST_ICONS', 'Yes', 'Use pretty pictures?', '6', '19', 'zen_cfg_select_option(array(\'No\', \'Yes\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Use cURL?', 'MODULE_SHIPPING_OZPOST_USE_CURL', 'No', 'Try Setting this to Yes if you get server connection errors', '6', '30', 'zen_cfg_select_option(array(\'No\', \'Yes\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Enable Debug?', 'MODULE_SHIPPING_OZPOST_DEBUG', 'No', 'See how parcels are created from individual items.</br>Shows all methods returned by the server, including possible errors. <strong>Do not enable in a production environment</strong>', '6', '20', 'zen_cfg_select_option(array(\'No\', \'Yes\'), ', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Postage Delay \(days\).', 'MODULE_SHIPPING_OZPOST_DOFFSET', '0', 'Add this number of days to the estimated delivery times. Useful if you don\'t mail your products out on a daily basis. <br /><strong>Tip:</strong> Use a negative number to disable the display.', '6', '21', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Tare percent.', 'MODULE_SHIPPING_OZPOST_TARE', '10', 'Add this percentage of the items total weight as the tare weight. (This module ignores the global settings that seems to confuse many users. 10% seems to work pretty well.).', '6', '22', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_SHIPPING_OZPOST_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '23', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_SHIPPING_OZPOST_TAX_CLASS', '0', 'Set Tax class or -none- if not registered for GST.', '6', '24', 'zen_get_tax_class_title', 'zen_cfg_pull_down_tax_classes(', now())");

    /////////////////////////  update tables //////

    $conn = mysql_connect(DB_SERVER, DB_SERVER_USERNAME,DB_SERVER_PASSWORD);
    $dbselect = mysql_select_db(DB_SERVER_DATABASE);
    $v = mysql_query("select * from " . TABLE_PRODUCTS . " limit 1" ) ;
    $inst = 1 ; $i = 0 ; $c = mysql_num_fields($v) ;
    while ($i < $c) {
        $r = mysql_field_name($v,$i) ;
        if($r == "products_length") { unset($inst) ; }  ;
        $i++ ;
    }
    mysql_close($conn) ;

    if(isset($inst)) {
        // echo "new" ;
        $db->Execute("ALTER TABLE " .TABLE_PRODUCTS. " ADD `products_length` FLOAT(6,2) NULL AFTER `products_weight`, ADD `products_height` FLOAT(6,2) NULL AFTER `products_length`, ADD `products_width` FLOAT(6,2) NULL AFTER `products_height`" ) ;
    }  else {
        //echo "update" ;
        $db->Execute("ALTER TABLE " .TABLE_PRODUCTS. " CHANGE `products_length` `products_length` FLOAT(6,2), CHANGE `products_height` `products_height` FLOAT(6,2), CHANGE `products_width`  `products_width`  FLOAT(6,2)" ) ;
    }

}

function remove() {
    global $db;
    $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_SHIPPING_OZPOST_%' ");
}

function keys() {
    return array(
	     'MODULE_SHIPPING_OZPOST_STATUS',
	     'MODULE_SHIPPING_OZPOST_SPCODE',
	     'MODULE_SHIPPING_OZPOST_TYPES1',
         'MODULE_SHIPPING_OZPOST_TYPES2',

         'MODULE_SHIPPING_OZPOST_LET_HANDLING',
         'MODULE_SHIPPING_OZPOST_RPP_HANDLING',
	     'MODULE_SHIPPING_OZPOST_INT_HANDLING',

         'MODULE_SHIPPING_OZPOST_RI_HANDLING',
         'MODULE_SHIPPING_OZPOST_EXP_HANDLING',

         'MODULE_SHIPPING_OZPOST_PPS_HANDLING',
	     'MODULE_SHIPPING_OZPOST_PPSE_HANDLING',
	     'MODULE_SHIPPING_OZPOST_COD_HANDLING',

	     'MODULE_SHIPPING_OZPOST_ECID_HANDLING',
	     'MODULE_SHIPPING_OZPOST_ECIM_HANDLING',

		 'MODULE_SHIPPING_OZPOST_HIDE_HANDLING',
	     'MODULE_SHIPPING_OZPOST_DIMS',
	     'MODULE_SHIPPING_OZPOST_WEIGHT_FORMAT',
	     'MODULE_SHIPPING_OZPOST_HIDE_PARCEL',
	     'MODULE_SHIPPING_OZPOST_ICONS',
	     'MODULE_SHIPPING_OZPOST_DEBUG',
	     'MODULE_SHIPPING_OZPOST_USE_CURL',
         'MODULE_SHIPPING_OZPOST_DOFFSET',
         'MODULE_SHIPPING_OZPOST_TARE',
	     'MODULE_SHIPPING_OZPOST_SORT_ORDER',
	     'MODULE_SHIPPING_OZPOST_TAX_CLASS');
    }


function _getAPdata($server,$request) {
    $time_start = microtime(true);

    if ((MODULE_SHIPPING_OZPOST_USE_CURL == "Yes") &&  (function_exists('curl_init'))) {

        $url = $server.$request ;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_VERBOSE, 0);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $vars);

        if (CURL_PROXY_REQUIRED == 'True') {
            $proxy_tunnel_flag = (defined('CURL_PROXY_TUNNEL_FLAG') && strtoupper(CURL_PROXY_TUNNEL_FLAG) == 'FALSE') ? false : true;
            curl_setopt ($ch, CURLOPT_HTTPPROXYTUNNEL, $proxy_tunnel_flag);
            curl_setopt ($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
            curl_setopt ($ch, CURLOPT_PROXY, CURL_PROXY_SERVER_DETAILS);
        }

        $data = curl_exec($ch);
        $error = curl_error($ch);
        curl_close($ch);

        if ($error != '') {
            global $messageStack;
            $messageStack->add_session('cURL communication ERROR: ' . $error, 'error');
            $data = '<error>Connection error: ' . $error . '</error>' ;
        }
        /////////////////////////////////////////////////////////////////
    } else {

        $http = new httpClient();
        if ($http->Connect($server, 80)) {
            $http->addHeader('Host', $server);
            $http->addHeader('User-Agent', 'Zen Cart [' . HTTP_SERVER . ']' );
            $http->addHeader('Connection', 'Close');
            if ($http->Get($request)) {
                $data = $http->getBody();
            }  else { $data  =  '<error>['.$data.']</error>' ; }

            $http->Disconnect();

        } else  {  $data = '<error>Connection error</error>';  }
    }

    ////////////////////////////////////////////

    if ( MODULE_SHIPPING_OZPOST_DEBUG == "Yes" ) {
        echo "<center><table border=1 width=95% ><tr><td>Server response time " . round(microtime(true) - $time_start,3) . "ms</td></tr></table></center>" ;
    }
    return $data ;
}

}  // end class
?>